#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "ctype.h"

#if !defined(_lint) && !defined(MSDOS)
static char rcsid[] OPTIONAL = "$Id: cleanup.c,v 1.4 1996/06/22 18:20:37 root Exp root $";
#endif

int main (int argc, char *argv[]);

static char UDefbak[] =  NOSDIR"/spool/users.bak";
static char UDefaults[] =  NOSDIR"/spool/users.dat";

#define NULLFILE ((FILE *) 0)
#define NULLCHAR ((char *) 0)

int
main(argc,argv)
int argc;
char *argv[];
{
FILE *Ufile, *tfile;
char buf[256], *cp, *cp2, *cp3;
int nope;
int didone;
char c;

	/* Save old defaults file to backup */
	unlink(UDefbak);
	if(rename(UDefaults,UDefbak))
		return 0;
        if ((tfile = fopen(UDefbak,"r")) != NULLFILE) {
        	if ((Ufile = fopen(UDefaults,"w")) == NULLFILE)	  {
        		fclose (tfile);
        		return 0;
        	}
       	        while(fgets(buf,sizeof(buf),tfile) != NULLCHAR)	{
			cp = strchr (buf, ' ');
			*cp++ = 0;
			cp2 = buf;
			nope = 0;
			while (*cp2)	{
				if (!isalnum (*cp2))	{
					nope = 1;
					break;
				}
				cp2++;
			}
			if (nope)
				continue;

			/* write user name */
			fputs (buf, Ufile);
			fputc (' ', Ufile);
			cp2 = strchr (cp, ' ');
			*cp2++ = 0;
			cp3 = strchr (&cp[1], '@');
			if (cp3)
				*cp3 = 0;
			cp3 = strchr (cp, '.');
			if (cp3)
				*cp3 = 0;

			/* write home bbs */
			fputs (cp, Ufile);
			fputc (' ', Ufile);
			while (*cp2 != '(')
				cp2++;
			cp = strchr (cp2, ')');
			cp++;
			c = *cp;
			*cp++ = 0;

			/* write realname */
			fputs (cp2, Ufile);
			fputc (' ', Ufile);
			if (c != ' ')
				*--cp = c;
			cp2 = strchr (cp, ' ');
			*cp2++ = 0;

			/* write timestamp */
			fputs (cp, Ufile);
			fputc (' ', Ufile);
			cp = strchr (cp2, ' ');
			*cp++ = 0;

			/* write more lines */
			fputs (cp2, Ufile);
			fputc (' ', Ufile);

			didone = 0;
			while (*cp)	{
				if (*cp != ' ')	{
					if (*cp == 'C' && didone)
						fputc (' ', Ufile);
					fputc (*cp, Ufile);
					didone = 1;
				}
				cp++;
			}
               	}
               	fclose(tfile);
               	fclose(Ufile);
        } else
	        rename(UDefbak,UDefaults);
	return 0;
}


