#ifndef _MAILUTIL_H
#define _MAILUTIL_H

#ifndef _STDIO_H
#include <stdio.h>
#endif

/* Header types */
#define	NOHEADER 	-1
#define APPROVED	0
#define	FROM		1
#define	TO		2
#define	DATE		3
#define	MSGID		4
#define	SUBJECT		5
#define	RECEIVED	6
#define	SENDER		7
#define	REPLYTO		8
#define STATUS		9
#define BBSTYPE		10
#define XFORWARD	11
#define CC		12
#define RRECEIPT	13
#define APPARTO		14
#define ERRORSTO	15
#define ORGANIZATION    16
#define NEWSGROUPS	17
#define PATH		18
#define XBBSHOLD	19
#define XMAILGROUP	20
#define MSGTYPE		21
#define XBID		22
#define UNKNOWN		23

extern const char *Hdrs[];

#define MAXREWRITERECURSION	10

int recvmail __ARGS((int s, char *buf, unsigned len, FILE *fp, int trace));
int copymail __ARGS((char *buf, unsigned len, FILE *fp, char* mail_to));

#ifndef _SMTP_H
int mlock __ARGS((const char *thedir,char *id));
void rmlock __ARGS((const char *thedir,char *id));
char *getname __ARGS((char *cp));
#endif

char *getaddress __ARGS((char *string,int cont));
int htype __ARGS((char *s));
#ifndef _MAILBOX_H
char *rewrite_address __ARGS((const char *addr, int recursionlevel));
#endif

#endif  /* _MAILUTIL_H */
