#if !defined(_AXNEG_H) && defined(AXNEGOTIATION)
#define _AXNEG_H

#ifdef __GNUC__
struct ax25_cb;			/* forward declaration */
#endif

#define QBIT_NREQ	0x80
#define QBIT_NREPLY	0x81

extern int AXNegotiation;

typedef struct {
	char param;
} neg_classA ;

typedef struct {
	char param[2];
} neg_classB;

typedef struct {
	char param[3];
} neg_classC;


struct ax_neg {
	/* these are merely to test and placehold, till complete */
	neg_classA compmode;		/* compression on/off */
	neg_classC compparms;		/* compression parameters */
};
#define NULLAXNEG ((struct ax_neg)0)


void AXNegotiation_request __ARGS((struct ax25_cb *axp, unsigned char *data, int size));
void AXNegotiation_reply __ARGS((struct ax25_cb *axp, unsigned char *data, int size));


#endif /* !_AXNEG_H && AXNEGOTIATION */

