/* Mods by PA0GRI */
#ifndef _COMMANDS_H
#define _COMMANDS_H

#include "cmdparse.h"

/* In 8250.c, amiga.c */
int doasystat __ARGS((int argc,char *argv[],void *p));

/* In alloc.c */
int domem __ARGS((int argc,char *argv[],void *p));

/* In amiga.c */
int doamiga __ARGS((int argc,char *argv[],void *p));

/* In arpcmd.c */
int doarp __ARGS((int argc,char *argv[],void *p));

/* In asy.c */
int asy_attach __ARGS((int argc,char *argv[],void *p));
int doasycomm __ARGS((int argc,char *argv[],void *p));

/* In at.c */
int doat __ARGS((int argc,char *argv[],void *p));

/* In ax25.c */
int axip_attach __ARGS((int argc,char *argv[],void *p));

/* In ax25aar.c */
int doax25autoroute __ARGS((int argc,char *argv[],void *p));

/* In ax25cmd.c */
int doax25 __ARGS((int argc,char *argv[],void *p));
int doaxstat __ARGS((int argc,char *argv[],void *p));
int doaxheard __ARGS((int argc,char *argv[],void *p));
int doaxdest __ARGS((int argc,char *argv[],void *p));
int doconnect __ARGS((int argc,char *argv[],void *p));
int donralias __ARGS ((int argc, char *argv[], void *p));
int ifax25 __ARGS((int argc,char *argv[],void *p));

/* In bmutil.c */
int issysarea __ARGS((const char *name));
int isarea __ARGS((char *name));

/* In bid_wp.c */
#ifdef WPAGES
extern int dooldwpages __ARGS ((int argc, char *argv[], void *p));
#endif

/* In bootp.c */
int dobootp __ARGS((int argc,char *argv[],void *p));

/* In bootpcmd.c */
int bootpdcmd __ARGS((int argc,char *argv[],void *p));

/* In buckbook.c  */
int docallserver __ARGS((int argc,char *argv[],void *p));
int docdrom __ARGS((int argc, char *argv[], void *p));

/* In calldbd.c */
int cdbstart __ARGS((int argc,char *argv[],void *p));
int cdb0 __ARGS((int argc,char *argv[],void *p));
int docallbook __ARGS((int argc,char *argv[],void *p));

/* In convers.c */
int DisplayFile __ARGS((const char *fname,int thesocket));
#ifdef CONVERS
int doconvers __ARGS((int argc, char **argv, void *p));
int conv1 __ARGS((int argc, char **argv, void *p));
int conv0 __ARGS((int argc, char **argv, void *p));
#endif
void conv_randomize __ARGS((void));
int conv_random __ARGS((int num, int base));

/* In crontab.c */
#ifdef CRONTAB
int docrontab __ARGS((int argc, char **argv, void *p));
int cron1 __ARGS((int argc, char **argv, void *p));
int cron0 __ARGS((int argc, char **argv, void *p));
#endif

/* In dialer.c */
int dodialer __ARGS((int argc,char *argv[],void *p));

/* In dirutil.c */
int docd __ARGS((int argc,char *argv[],void *p));
int dodir __ARGS((int argc,char *argv[],void *p));
int domkd __ARGS((int argc,char *argv[],void *p));
int dormd __ARGS((int argc,char *argv[],void *p));
#ifdef MSDOS
extern int dodrive __ARGS ((int argc, char *argv[], void *p));
#endif

/* In domain.c */
int dodomain __ARGS((int argc,char *argv[],void *p));

/* In drsi.c */
int dodrstat __ARGS((int argc,char *argv[],void *p));
int dr_attach __ARGS((int argc,char *argv[],void *p));
int dodr __ARGS((int argc,char *argv[],void *p));

/* In eagle.c */
int eg_attach __ARGS((int argc,char *argv[],void *p));
int doegstat __ARGS((int argc,char *argv[],void *p));

/* In ec.c */
int doetherstat __ARGS((int argc,char *argv[],void *p));
int ec_attach __ARGS((int argc,char *argv[],void *p));

/* In expire.c */
int doexpire __ARGS((int argc,char *argv[],void *p));
int dooldbids __ARGS((int argc,char *argv[],void *p));
void RenewWPages __ARGS((void));

/* In export.c */
#ifdef BBSEXPORT
extern int doexport __ARGS ((int argc, char *argv[], void *p));
#endif

/* In finger.c */
int dofinger __ARGS((int argc,char *argv[],void *p));

/* In fingerd.c */
int finstart __ARGS((int argc,char *argv[],void *p));
int fin0 __ARGS((int argc,char *argv[],void *p));

/* In forward.c */
int fwdstart __ARGS((int argc,char *argv[],void *p));
int fwd0 __ARGS((int argc,char *argv[],void *p));
void netPrompt __ARGS((void));
int AREAlookup __ARGS((char *area,int theindex));
void fwdlockit __ARGS((char *name));
void fwdunlockit __ARGS((char *name));

/* In ftpcli.c */
int doftp __ARGS((int argc,char *argv[],void *p));
int doftype __ARGS((int argc,char *argv[],void *p));
int doabort __ARGS((int argc,char *argv[],void *p));

/* In ftpserv.c */
int ftpstart __ARGS((int argc,char *argv[],void *p));
int ftp0 __ARGS((int argc,char *argv[],void *p));
int doftptdisc __ARGS((int argc,char *argv[],void *p));
int doftpmaxclients __ARGS((int argc,char *argv[],void *p));

/* In ftpsubr.c */
int md5hash __ARGS((FILE *fp,char hash[],int ascii));

/* In fwdcmd.c */
#ifdef MBFWD
extern int doforward __ARGS ((int argc, char *argv[], void *p));
#endif

/* In getline.c */
char * getline __ARGS((FILE *fp));

/* In hapn.c */
int dohapnstat __ARGS((int argc,char *argv[],void *p));
int hapn_attach __ARGS((int argc,char *argv[],void *p));

/* In help.c */
void dohelper __ARGS((const char *title,register struct cmds *cmdp,const char *stopstr,const char *filename,const char *search));

/* In hop.c */
int dohop __ARGS((int argc,char *argv[],void *p));

/* In http.c */
int httpstart __ARGS((int argc,char *argv[],void *p));
int http0 __ARGS((int argc, char *argv[], void *p));
int dohttp __ARGS((int argc,char *argv[],void *p));

/* In hs.c */
int dohs __ARGS((int argc,char *argv[],void *p));
int hs_attach __ARGS((int argc,char *argv[],void *p));

/* In icmpcmd.c */
int doicmp __ARGS((int argc,char *argv[],void *p));
int doping __ARGS((int argc,char *argv[],void *p));

/* In iface.c */
int doifconfig __ARGS((int argc,char *argv[],void *p));
int dodetach __ARGS((int argc,char *argv[],void *p));
void removetrace __ARGS((void));

/* In import.c */
#ifdef BBSIMPORT
extern int doimport __ARGS ((int argc, char *argv[], void *p));
#endif

/* In ipcmd.c */
int doip __ARGS((int argc,char *argv[],void *p));
int doroute __ARGS((int argc,char *argv[],void *p));
int doipheard __ARGS((int argc,char *argv[],void *p));

/* In kiss.c */
int kiss_attach __ARGS((int argc,char **argv,void *p));

/* In ksubr.c */
int ps __ARGS((int argc,char *argv[],void *p));
int dostackcheck __ARGS((int argc,char *argv[],void *p));

/* In lapb.c */
int dorose __ARGS((int argc,char *argv[],void *p));

/* In look.c */
int dolook __ARGS((int argc,char *argv[],void *p));

/* In lzw.c */
int dolzw __ARGS((int argc,char *argv[],void *p));

/* In mailbox.c */
int dopbbs __ARGS((int argc,char *argv[],void *p));
int doinetcallserver __ARGS((int argc,char *argv[],void *p));
void setMaintenance __ARGS((void));
void clearMaintenance __ARGS((void));

/* In mailfor.c */
int dombrline __ARGS((int argc,char *argv[],void *p));

/* In main.c */
int dodelete __ARGS((int argc,char *argv[],void *p));
int dorename __ARGS((int argc,char *argv[],void *p));
int doexit __ARGS((int argc,char *argv[],void *p));
int dohostname __ARGS((int argc,char *argv[],void *p));
int dolog __ARGS((int argc,char *argv[],void *p));
int dohelp __ARGS((int argc,char *argv[],void *p));
int doattach __ARGS((int argc,char *argv[],void *p));
int doparam __ARGS((int argc,char *argv[],void *p));
int domode __ARGS((int argc,char *argv[],void *p));
int doman __ARGS((int argc,char *argv[],void *p));
int domore __ARGS((int argc,char *argv[],void *p));
int donothing __ARGS((int argc,char *argv[],void *p));
int donrstat __ARGS((int argc,char *argv[],void *p));
int doescape __ARGS((int argc,char *argv[],void *p));
int doremote __ARGS((int argc,char *argv[],void *p));
int doboot __ARGS((int argc,char *argv[],void *p));
int dosource __ARGS((int argc,char *argv[],void *p));
int domdump __ARGS((int argc,char *argv[],void *p));
int dostatus __ARGS((int argc,char *argv[],void *p));
int domotd __ARGS((int argc,char *argv[],void *p));
int dofmotd __ARGS((int argc,char *argv[],void *p));
int dothirdparty __ARGS((int argc,char *argv[],void *p));
int dotail __ARGS((int argc,char *argv[],void *p));
int dolock __ARGS((int argc,char *argv[],void *p));
int dounlock __ARGS((int argc,char *argv[],void *p));
int morecmd __ARGS((int argc,char *argv[],void *p));
int docopy __ARGS((int, char **, void *));
int doerror __ARGS((int, char **, void *));
int dowrite __ARGS((int, char **, void *));
int dowriteall __ARGS((int, char **, void *));
int doprompt __ARGS((int, char **, void *));
int dohistory __ARGS((int, char **, void *));
int dorepeat __ARGS((int, char **, void *));
void mail_error __ARGS((const char *fmt, ...));
int dosystime __ARGS((int argc,char *argv[],void *p));
#ifdef SETPSINFO
void setprocname __ARGS((char *str));
#endif

/* In mbfilter.c */
int mbfilter __ARGS((FILE *fp,const char *from,const char *to));

/* In merge.c */
FILE *fopennew __ARGS((const char *fname, const char *mode));
FILE *fopentmp __ARGS((const char *fname, const char *mode));
int merge __ARGS((const char *fname));

/* In misc.c */
int readhex __ARGS((char *out,char *in,int size));

/* In nntpcli.c */
int donntp __ARGS((int argc,char *argv[],void *p));

/* In nntpserv.c */
#ifdef	NNTPS
extern int nntp0 __ARGS ((int argc, char *argv[], void *p));
extern int nntp1 __ARGS ((int argc, char *argv[], void *p));
#endif

/* In nrcmd.c */
int donetrom __ARGS((int argc,char *argv[],void *p));
int nr_attach __ARGS((int argc,char *argv[],void *p));

/* in pbbscmd.c */
int douptime __ARGS((int, char **, void *));
int dombchat __ARGS((int, char **, void *));

/* In pc.c */
int doshell __ARGS((int argc,char *argv[],void *p));
int dofkey __ARGS((int argc,char *argv[],void *p));
int doisat __ARGS((int argc,char *argv[],void *p));
int dobmail __ARGS((int argc,char *argv[],void *p));
int dobackg __ARGS((int argc,char *argv[],void *p));
int dowatchdog __ARGS((int argc,char *argv[],void *p));
#ifdef XSPAWN
extern int doxspawn __ARGS ((int argc, char *argv[], void *p));
#endif

/* In pc100.h: */
int pc_attach __ARGS((int argc,char *argv[],void *p));

/* In pktdrvr.c */
int pk_attach __ARGS((int argc,char *argv[],void *p));

/* In pi.c */
int pi_attach __ARGS((int argc,char *argv[],void *p));
int dopistat __ARGS((int argc,char *argv[],void *p));

/* In pipe.c */
#ifdef UNIX
extern int dopipe __ARGS ((int argc, char *argv[], void *p));
#endif

/* In popcli.c */
int dopop __ARGS((int argc,char *argv[],void *p));

/* In popserv.c */
int pop1 __ARGS((int argc,char *argv[],void *p));
int pop0 __ARGS((int argc,char *argv[],void *p));

/* in pop2serv.c */
int pop2start   __ARGS((int argc,char *argv[],void *p));
int pop2stop    __ARGS((int argc,char *argv[],void *p));

/* in pop3serv.c */
int pop3start   __ARGS((int argc,char *argv[],void *p));
int pop3stop    __ARGS((int argc,char *argv[],void *p));

/* In rarp.c */
int dorarp __ARGS((int argc,char *argv[],void *p));

/* In reqsvr.c */
int rdaemon __ARGS((FILE *data,const char *replyto, const char *from, const char *to, const char *msg, const char msgtype, int mode));
int rdaemon_str __ARGS((char *str,const char *replyto, const char *from, const char *to, const char *msg, const char msgtype, int mode));
int rmail __ARGS((FILE *fp,const char *from));
#ifdef REQSVR
int reqsvr __ARGS((FILE *fp,const char *from));
#endif

/* In ripcmd.c */
int doaddrefuse __ARGS((int argc,char *argv[],void *p));
int dodroprefuse __ARGS((int argc,char *argv[],void *p));
int dorip __ARGS((int argc,char *argv[],void *p));
int doripadd __ARGS((int argc,char *argv[],void *p));
int doripdrop __ARGS((int argc,char *argv[],void *p));
int doripkick __ARGS((int argc,char *argv[],void *p));
int doripinit __ARGS((int argc,char *argv[],void *p));
int doripmerge __ARGS((int argc,char *argv[],void *p));
int doripreq __ARGS((int argc,char *argv[],void *p));
int doripstat __ARGS((int argc,char *argv[],void *p));
int doripstop __ARGS((int argc,char *argv[],void *p));
int doriptrace __ARGS((int argc,char *argv[],void *p));
int doripttl __ARGS((int argc,char *argv[],void *p));

/* In rdate.c */
int dordate __ARGS((int argc,char *argv[],void *p));

/* In register.c */
int is_registered __ARGS((void));
void reg_status __ARGS((void));
int doregister __ARGS((int argc,char *argv[],void *p));
int doregistry __ARGS((int argc,char *argv[],void *p));

/* In reject.c */
int reject __ARGS((const char *cmdstr, int rmtuser));

/* In reqsvr.c */
void parseheader __ARGS((FILE *fp,char *from, char *subject, char *to, char *bid, char *buf,long *startat));
int dosendmail __ARGS ((int argc, char *argv[], void *p));

/* In rlogin.c */
int dorlogin __ARGS((int argc,char *argv[],void *p));

/* In rspfcmd.c */
int dorspf __ARGS((int argc,char **argv,void *p));

/* In scc.c */
int scc_attach __ARGS((int argc,char *argv[],void *p));
int dosccstat __ARGS((int argc,char *argv[],void *p));

/* In script.c */
int dogone __ARGS((int argc,char *argv[],void *p));
int dohere __ARGS((int argc,char *argv[],void *p));
int dosleep __ARGS((int argc,char *argv[],void *p));
int dopause __ARGS((int argc,char *argv[],void *p));
int doecho __ARGS((int argc,char *argv[],void *p));
char * _variable_expansion __ARGS((char *input));
int doalias __ARGS((int argc,char *argv[],void *p));
int dounalias __ARGS((int argc,char *argv[],void *p));
int doset __ARGS((int argc,char *argv[],void *p));
int dounset __ARGS((int argc,char *argv[],void *p));
int doincr __ARGS((int argc,char *argv[],void *p));
int dodecr __ARGS((int argc,char *argv[],void *p));
int dogoto __ARGS((int argc,char *argv[],void *p));
int dolabel __ARGS((int argc,char *argv[],void *p));
int doif __ARGS((int argc,char *argv[],void *p));
int doelse __ARGS((int argc,char *argv[],void *p));
int doforeach __ARGS((int argc,char *argv[],void *p));
int dowhile __ARGS((int argc,char *argv[],void *p));
int dountil __ARGS((int argc,char *argv[],void *p));
int doifdef __ARGS((int argc,char *argv[],void *p));
int doifndef __ARGS((int argc,char *argv[],void *p));


/* In search.c */
int searchfileFP __ARGS((register char *searchfor,register FILE *fp,register char *buf,int entrysize, int *passes, int searchlen));
int searchfile __ARGS((register char *searchfor,const char *fname,register char *buf,int entrysize, int *passes, int searchlen));

/* In security.c */
extern int dosecurity __ARGS ((int argc, char *argv[], void *p));

/* In session.c */
int dosession __ARGS((int argc,char *argv[],void *p));
int go __ARGS((int argc,char *argv[],void *p));
int doclose __ARGS((int argc,char *argv[],void *p));
int doreset __ARGS((int argc,char *argv[],void *p));
int dokick __ARGS((int argc,char *argv[],void *p));
int dorecord __ARGS((int argc,char *argv[],void *p));
int doupload __ARGS((int argc,char *argv[],void *p));

/* In smisc.c */
int deleteserver __ARGS((int *mysocket));
int installserver __ARGS((int argc,char *argv[],int *mysocket,const char *listener,
	int defport, const char *procname,
	void (*proc) __ARGS((int,void *,void *)),
	unsigned int size, void *parm));
int dis1 __ARGS((int argc,char *argv[],void *p));
int dis0 __ARGS((int argc,char *argv[],void *p));
int echo1 __ARGS((int argc,char *argv[],void *p));
int echo0 __ARGS((int argc,char *argv[],void *p));
int time1 __ARGS((int argc,char *argv[],void *p));
int time0 __ARGS((int argc,char *argv[],void *p));
int daytime1 __ARGS((int argc,char *argv[],void *p));
int daytime0 __ARGS((int argc,char *argv[],void *p));
int rem1 __ARGS((int argc,char *argv[],void *p));
int rem0 __ARGS((int argc,char *argv[],void *p));
int quote1 __ARGS((int argc,char *argv[],void *p));
int quote0 __ARGS((int argc,char *argv[],void *p));
extern int doquote __ARGS ((int argc, char *argv[], void *p));

#ifdef UNIX
/* In sessmgr.c */
extern int dosessmgr __ARGS((int, char **, void *));
#endif

#ifdef SOUNDS
int dosounds __ARGS((int argc,char *argv[],void *p));
int playsound __ARGS((const char *soundname));
int setsoundstr __ARGS((int argc,char *argv[],char **sound));
#endif

#ifdef RLOGINSERV
int rlogin0 __ARGS ((int argc, char *argv[], void *p));
int rlogin1 __ARGS ((int argc, char *argv[], void *p));
#endif

#ifdef TUTOR
int tutor0 __ARGS ((int argc, char *argv[], void *p));
int tutor1 __ARGS ((int argc, char *argv[], void *p));
int info0 __ARGS ((int argc, char *argv[], void *p));
int info1 __ARGS ((int argc, char *argv[], void *p));
int news0 __ARGS ((int argc, char *argv[], void *p));
int news1 __ARGS ((int argc, char *argv[], void *p));
extern int dotutor __ARGS ((int argc, char *argv[], void *p));
extern int doinfo __ARGS ((int argc, char *argv[], void *p));
extern int donews __ARGS ((int argc, char *argv[], void *p));
#endif

#ifdef TRACESERVER
int trace0 __ARGS ((int argc, char *argv[], void *p));
int trace1 __ARGS ((int argc, char *argv[], void *p));
#endif

/* In smtpcli.c */
int dosmtp __ARGS((int argc,char *argv[],void *p));

/* In smtpserv.c */
int smtp1 __ARGS((int argc,char *argv[],void *p));
int smtp0 __ARGS((int argc,char *argv[],void *p));
char *ptime __ARGS((long *t));

/* In sockcmd.c */
int dosock __ARGS((int argc,char *argv[],void *p));
int dokicksocket __ARGS((int argc,char *argv[],void *p));
int doresetsocket __ARGS((int argc,char *argv[],void *p));

/* In ssaver.c */
#ifdef SCREENSAVER
void screensaver __ARGS((void));
void sskick __ARGS((void));
int ssenabled __ARGS((void));
extern int dossaver __ARGS ((int argc, char *argv[], void *p));
#endif


/* In stats.c */
#ifdef STATS
extern void statsdaemon __ARGS ((int i, void *v1, void *v2));
int dostats __ARGS((int argc,char *argv[],void *p));
int doSTATclear __ARGS((int argc,char *argv[],void *p));
int doSTATsave __ARGS((int argc,char *argv[],void *p));
int doSTATload __ARGS((int argc,char *argv[],void *p));
#ifdef STATS_USE
void STATS_adduse __ARGS((int which));
int STATdaily_use __ARGS((int argc,char *argv[],void *p));
int STATweekly_use __ARGS((int argc,char *argv[],void *p));
int STATmonthly_use __ARGS((int argc,char *argv[],void *p));
int STATyearly_use __ARGS((int argc,char *argv[],void *p));
int STATgeneral_use __ARGS((int argc,char *argv[],void *p));
#endif
#ifdef STATS_MSG
void STATS_addmsg __ARGS((int which, int amount));
int STATdaily_msg __ARGS((int argc,char *argv[],void *p));
int STATweekly_msg __ARGS((int argc,char *argv[],void *p));
int STATmonthly_msg __ARGS((int argc,char *argv[],void *p));
int STATyearly_msg __ARGS((int argc,char *argv[],void *p));
int STATgeneral_msg __ARGS((int argc,char *argv[],void *p));
#endif
#ifdef STATS_TFC
void STATS_addtfc __ARGS((int which, int amount));
int STATdaily_tfc __ARGS((int argc,char *argv[],void *p));
int STATweekly_tfc __ARGS((int argc,char *argv[],void *p));
int STATmonthly_tfc __ARGS((int argc,char *argv[],void *p));
int STATyearly_tfc __ARGS((int argc,char *argv[],void *p));
int STATgeneral_tfc __ARGS((int argc,char *argv[],void *p));
#endif
#ifdef STATS_AREA
void STATS_addarea __ARGS((int which, int amount, char *name));
int STATdaily_area __ARGS((int argc,char *argv[],void *p));
int STATweekly_area __ARGS((int argc,char *argv[],void *p));
int STATmonthly_area __ARGS((int argc,char *argv[],void *p));
int STATyearly_area __ARGS((int argc,char *argv[],void *p));
int STATgeneral_area __ARGS((int argc,char *argv[],void *p));
#endif
#ifdef STATS_FWD
void STATS_addfwd __ARGS((int which, int amount, char *name));
int STATdaily_fwd __ARGS((int argc,char *argv[],void *p));
int STATweekly_fwd __ARGS((int argc,char *argv[],void *p));
int STATmonthly_fwd __ARGS((int argc,char *argv[],void *p));
int STATyearly_fwd __ARGS((int argc,char *argv[],void *p));
int STATgeneral_fwd __ARGS((int argc,char *argv[],void *p));
#endif
#endif

/* In sw.c */
int doswatch __ARGS((int argc,char *argv[],void *p));

/* In tcpcmd.c */
int dotcp __ARGS((int argc,char *argv[],void *p));

/* In tcpgate.c */
#ifdef TCPGATE
int tcpgate1 __ARGS ((int argc, char *argv[], void *p));
int tcpgate0 __ARGS ((int argc, char *argv[], void *p));
#endif

/* In telnet.c */
int doechomode __ARGS((int argc,char *argv[],void *p));
int doeol __ARGS((int argc,char *argv[],void *p));
int dotelnet __ARGS((int argc,char *argv[],void *p));
int dottylink __ARGS((int argc,char *argv[],void *p));
int dobbs __ARGS((int argc,char *argv[],void *p));
int doconf __ARGS((int argc,char *argv[],void *p));

/* In term.c */
#ifdef TERMSERVER
int doterm __ARGS((int argc,char *argv[],void *p));
int term0 __ARGS((int argc,char *argv[],void *p));
int term1 __ARGS((int argc,char *argv[],void *p));
#endif

/* In tip.c */
int dotip __ARGS((int argc,char *argv[],void *p));

/* In tipmail.c */
int telnet0 __ARGS ((int argc, char *argv[], void *p));
int telnet1 __ARGS ((int argc, char *argv[], void *p));
#ifdef TIPMAIL
int tipstart __ARGS ((int argc, char *argv[], void *p));
int tip0 __ARGS ((int argc, char const *argv[], void *p));
#endif

/* In tnos.c */
extern int docolor __ARGS ((int argc, char *argv[], void *p));
extern int dostatline __ARGS ((int argc, char *argv[], void *p));
#if defined(TNOS_68K) || defined(UNIX)
extern void screendaemon __ARGS ((int i, void *v1, void *v2));
#endif

/* In trace.c */
int dotrace __ARGS((int argc,char *argv[],void *p));
int dostrace __ARGS((int argc,char *argv[],void *p));

/* In ttylink.c */
int ttylstart __ARGS((int argc,char *argv[],void *p));
int ttyl0 __ARGS((int argc,char *argv[],void *p));
int chatcmd __ARGS((int argc,char *argv[],void *p));

/* In tutor.c */
#ifdef SKIP_HACK
char *skipnonwhite __ARGS((char *ptr));
char *skipwhite __ARGS((char *ptr));
#else
char *skipnonwhite __ARGS((char const *ptr));
char *skipwhite __ARGS((char const *ptr));
#endif
void trimright __ARGS((char *ptr));
void trimrightCR __ARGS((char *ptr));

#ifdef TUTOR
extern int doscript __ARGS ((int argc, char *argv[], void *p));
#endif

/* In twin_dr.c/twin_at.c  - Gracilis PackeTwin */
int tsync_attach __ARGS((int argc,char *argv[],void *p));
int do_tsync_stat __ARGS((int argc,char *argv[],void *p));
int do_tsync_dump __ARGS((int argc,char *argv[],void *p));

/* In udpcmd.c */
int doudp __ARGS((int argc,char *argv[],void *p));

/* In unixasy.c */
int Unixlockfile __ARGS((char const *name, int dev, char const *_basename));
int asy_vmin __ARGS ((int dev, long pktsize));
int asy_rts __ARGS ((int dev, unsigned long onoff));

/* In version.c */
int doversion __ARGS((int argc,char *argv[],void *p));

/* In view.c */
int doview __ARGS((int argc,char *argv[],void *p));

/* In warnings.c */
int dowarnings __ARGS ((int argc, char *argv[], void *p));

#endif  /* _COMMANDS_H */
