/* Include needed for extended bbs support - WG7J */
#ifndef _MAILFOR_H
#define _MAILFOR_H

#ifndef _AX25_H
#include "ax25.h"
#endif

int domftimer __ARGS((int argc,char *argv[],void *p));

/*List of bbses we forward to, to check the R: lines for */
#define FWDBBSLEN 9 /* call + optional ssid, eg. "KB7BHF-15" */
#define NUMFWDBBS 32 /* Check for 32 bbs's max (arbitrary !) */

/* In mailfor.c */
extern int Numfwds;
extern int Checklock;
extern int Rreturn;
extern int Rfwdcheck;
extern int Rdate;

/* List of area names to exclude from mail-for beacon */
struct no_mf {
    struct no_mf *next;
    char area[9];
};
#define NULLMF (struct no_mf *)0
extern struct no_mf *No_mf;


#ifdef ALERTMONITOR
/* List of area names to monitor for incoming mail */
struct mfalert {
    struct mfalert 	*next;
    char 		area[9];
};

#define NULLMFA (struct mfalert *)0
extern struct mfalert *mf_alerts;

void alertarea __ARGS((char *area));

#endif

#endif /*_MAILFOR_H*/
