#ifndef _X_H_
#define _X_H_

#ifdef XSERVER

#ifndef	_TIMER_H
#include "timer.h"
#endif

struct xcontrol {
	int		s;		/* socket for status info */
	char		*host;		/* host info */
	int		txstatusinfo;	/* do we TX status info? */
	struct timer	update;		/* timer for update */
	struct xcontrol *next;
};

#define NULLX ((struct xcontrol *)0)

struct xhost {
	char	*host;		/* host info */
	struct xhost *next;
};

#define NULLXHOST ((struct xhost *)0)

#define X_BBS		1
#define X_CONF		2
#define X_FTP		4
#define X_TUT		8
#define X_MSG		16
#define X_HOLD  	32
#define X_ALERT 	64
#define X_SCREEN	128
#define X_ALL	(X_BBS | X_CONF | X_FTP | X_TUT | X_MSG | X_HOLD | X_ALERT | X_SCREEN)
	

void xnotify __ARGS((int which));
int xserver0 __ARGS((int argc, char *argv[], void *p));
int xserver1 __ARGS((int argc, char *argv[], void *p));
int doxwindows __ARGS((int argc, char *argv[], void *p));

#define Xupdateinit 5
#define SCMD "~tk~"
#define ECMD "~\n"

#endif /* XSERVER */
#endif /* _X_H_ */
